class HHMMClass {
  int posX,posY;
  int hh_mm;
  float zoom;
  Digit[] digits = new Digit[4];
  
  HHMMClass() {
    posX=posY=0;
    zoom=1.0;
    hh_mm = 0x950;
    for(int i=0;i<4;i++) {
      if (i < 2)
        digits[i]=new Digit(100*i,50,zoom);
      else
        digits[i]=new Digit(100*(i+1),50,zoom);
    }
  }
  
  HHMMClass(int posx,int posy,float grossissement) {
    zoom = grossissement;
    posX=posx; posY=posy;
    hh_mm = 0x950;
    for(int i=0;i<4;i++) {
      if (i < 2)
        digits[i]=new Digit(int(100*i+posX),int(50+posY),zoom);
      else
        digits[i]=new Digit(int(100*(i+1)+posX),int(50+posY),zoom);
    }
  }
  
  void affiche(int red,int green,int blue) {
    for(int i=0;i<4;i++) {
      digits[3-i].put(hh_mm >> (4*i) & 0xF);
      digits[3-i].affiche7segs(red,green,blue);
    }
    if ((second() & 1) == 1)
      fill(red,green,blue);
    else 
      fill(200);
      
    ellipse(int((260+posX)*zoom),int((100+posY)*zoom),20*zoom,20*zoom);
    ellipse(int((255+posX)*zoom),int((150+posY)*zoom),20*zoom,20*zoom);
  }
  
  void updateHHMM() {
    int temp;
    temp = hour();
    hh_mm = ((temp/10) << 12)+((temp%10)<<8);
    temp = minute();
    hh_mm += ((temp/10) << 4)+(temp%10);
  }
  void incrementHHMM() {
      (hh_mm)++;
      if ((hh_mm & 0x000F) > 0x0009)
        hh_mm += 0x0006;
      if ((hh_mm & 0x00F0) > 0x0050)
        hh_mm += 0x00A0;
      if ((hh_mm & 0x0F00) > 0x0900)
        hh_mm += 0x0600;
      if ((hh_mm & 0xFF00) > 0x2300)
        hh_mm = 0x0000;
  }
  void decrementHHMM() {
      (hh_mm)--;
      if ((hh_mm & 0x000F) == 0x000F)
      hh_mm -= 0x0006;
      if ((hh_mm & 0x00F0) == 0x00F0)
      hh_mm -= 0x00A0;
      if ((hh_mm & 0x0F00) == 0x0F00)
      hh_mm -= 0x0600;
      if ((hh_mm & 0xFFFF) > 0x2359)
      hh_mm = 0x2359;
  }
}